################################################
#          zABBER Scripts Handle File          #
################################################
#                                              #
#   This file handles all the script support   #
#   in zABBER.                                 #
#                                              #
################################################

set script(files) ""    ;#Filenames.
#set script(files,$file) ""    ;#Configuration of $file.
set script(interp) ""    ;#Currently-running interps.
#set script(interp,$file) ""    ;#Currently-running interps of $file.
#set script(interp,$file:$interp) ""    ;#AddExt stuff of $interp.

proc loadscripts {} {
global script

  set num [readini "Scripts/scripts.ini" "num"]
  if {!$num} {return}    ;#Return if $num is 0.
  for {set i 1} {$i<=$num} {incr i} {
	set file [readini "Scripts/scripts.ini" "script$i"]
	if {[set temp [script:handle:inf $file]]==-1} {continue}

	lappend script(files)        $file
	set     script(files,$file)  $temp
	set     script(interp,$file) ""

	foreach a "[lindex $temp 0]" {
		.popup_group.script add command -label "[lindex $a 0]" -command "script:start:groupmenu \"$file\" \"[lindex $a 1]\""
	}
	foreach a "[lindex $temp 1]" {
		.popup_user.script add command -label "[lindex $a 0]" -command "script:start:usermenu \"$file\" \"[lindex $a 1]\""
	}
	foreach a "[lindex $temp 2]" {
		.popup_nick.script add command -label "[lindex $a 0]" -command "script:start:nickmenu \"$file\" \"[lindex $a 1]\""
	}
  }
}

proc script:handle:inf {file} {
global temp

  if {![file exists "Scripts/$file.inf"] || ![file exists "Scripts/$file.tcl"]} {return -1}



#           +----------------------- GROUPMENU
#           |  +-------------------- USERMENU
#           |  |  +----------------- NICKMENU
#           |  |  |     +----------- SCRIPT NAME
#           |  |  |     |    +------ LOAD TK
#           |  |  |     |    | +---- RUNONMSG
#           |  |  |     |    | |
  set temp {"" "" "" "$file" 0 ""}

  set temp_ [interp create]
  set command  {foreach a [info vars] {unset $a}
		foreach a [info procs] {
			if {$a!="if" && $a!="unset" && $a!="rename"} {rename $a ""}
		}
		unset a
		rename if ""
		rename rename ""}
  $temp_ eval $command
  $temp_ alias "LOAD"      "script:handle:inf:LOAD"
  $temp_ alias "NAME"      "script:handle:inf:NAME"
  $temp_ alias "RUNONMSG"  "script:handle:inf:RUNONMSG"
  $temp_ alias "GROUPMENU" "script:handle:inf:GROUPMENU"
  $temp_ alias "USERMENU"  "script:handle:inf:USERMENU"
  $temp_ alias "NICKMENU"  "script:handle:inf:NICKMENU"

  set a [open "Scripts/$file.inf"]
  set b [read $a]
  close $a
  if {[catch {$temp_ eval $b}]} {interp delete $temp_; return -1}

  interp delete $temp_

  return $temp
}

proc script:handle:inf:LOAD {args} {
global temp
  if {$args=="TK"} {set temp [lreplace $temp 4 4 "1"]}
}

proc script:handle:inf:NAME {args} {
global temp
  if {$args!=""} {set temp [lreplace $temp 3 3 "$args"]}
}

proc script:handle:inf:RUNONMSG {args} {
global temp


#          +----------------------------------- Subject
#          |   +------------------------------- Say
#          |   |   +--------------------------- Priority
#          |   |   |   +----------------------- Thread
#          |   |   |   |   +------------------- From
#          |   |   |   |   |   +--------------- Nick
#          |   |   |   |   |   |  +------------ ExtTag
#          |   |   |   |   |   |  |  +--------- ExtVals
#          |   |   |   |   |   |  |  |   +----- ExtTxt
#          |   |   |   |   |   |  |  |   |  +-- Parameters
#          |   |   |   |   |   |  |  |   |  |
set list {"*" "*" "*" "*" "*" "*" "" "" "*" ""}

  foreach {tag value} $args {
	switch -- $tag {
		-subject   {set list [lreplace $list 0 0 $value]}
		-say       {set list [lreplace $list 1 1 $value]}
		-priority  {set list [lreplace $list 2 2 $value]}
		-thread    {set list [lreplace $list 3 3 $value]}
		-from      {set list [lreplace $list 4 4 $value]}
		-nick      {set list [lreplace $list 5 5 $value]}
		-exttag    {set list [lreplace $list 6 6 $value]}
		-extvals   {set list [lreplace $list 7 7 $value]}
		-exttxt    {set list [lreplace $list 8 8 $value]}
		-parameter {set list [lreplace $list 9 9 $value]}
	}
  }

  set abc [lindex $temp 5]
  lappend abc $list
  set temp [lreplace $temp 5 5 $abc]
}

proc script:handle:inf:GROUPMENU {command args} {
global temp

#         +------ Label
#         |  +--- Parameters
#         |  |
set list {"" ""}

  if {$command=="add"} {
	foreach {tag value} $args {
		switch -- $tag {
			-label     {set list [lreplace $list 0 0 $value]}
			-parameter {set list [lreplace $list 1 1 $value]}
		}
	}
  }

  set abc [lindex $temp 0]
  lappend abc $list
  set temp [lreplace $temp 0 0 $abc]
}


proc script:handle:inf:USERMENU {command args} {
global temp

#         +------ Label
#         |  +--- Parameters
#         |  |
set list {"" ""}

  if {$command=="add"} {
	foreach {tag value} $args {
		switch -- $tag {
			-label     {set list [lreplace $list 0 0 $value]}
			-parameter {set list [lreplace $list 1 1 $value]}
		}
	}
  }

  set abc [lindex $temp 1]
  lappend abc $list
  set temp [lreplace $temp 1 1 $abc]
}

proc script:handle:inf:NICKMENU {command args} {
global temp

#         +------ Label
#         |  +--- Parameters
#         |  |
set list {"" ""}

  if {$command=="add"} {
	foreach {tag value} $args {
		switch -- $tag {
			-label     {set list [lreplace $list 0 0 $value]}
			-parameter {set list [lreplace $list 1 1 $value]}
		}
	}
  }

  set abc [lindex $temp 2]
  lappend abc $list
  set temp [lreplace $temp 2 2 $abc]
}

proc script:start {file param} {
global script

  if {![file exists "Scripts/$file.tcl"]} {return}

  set temp [interp create]

  if {[lindex $script(files,$file) 4]} {load {} Tk $temp}

  $temp alias "exit" "script:command:exit" "$temp"
  $temp alias "addExt" "script:command:addExt" "$file" "$temp"
  $temp alias "delExt" "script:command:delExt" "$file" "$temp"
  $temp alias "sendMessage" "script:command:sendMessage"
  $temp eval "set argc [llength $param]; set argv \{$param\}"

  lappend script(interp)             $temp
  lappend script(interp,$file)       $temp
  set     script(interp,$file:$temp) ""

  set a [open "Scripts/$file.tcl"]
  set b [read $a]
  close $a

  $temp eval $b
}

proc script:start:groupmenu {file param} {
global script

  set gname [file tail [Tree:getselection .win.f.tree]]
  set param [script:decrypt:groupmenu $param $gname]

  script:start $file $param
}

proc script:start:usermenu {file param} {
global script

  set gname [lindex [set a [file split [Tree:getselection .win.f.tree]]] 1]
  set uname [lindex $a 2]
  set param [script:decrypt:usermenu $param $gname $uname]

  script:start $file $param
}

proc script:start:nickmenu {file param} {
global script JabberLib

  set gname [lindex [set a [file split [Tree:getselection .win.f.tree]]] 1]
  set uname [lindex $a 2]
  set nname [lindex $a 3]
  set prop  $JabberLib(roster,users,$uname,$nname)
  set stats [lindex $prop 0]
  set say   [lindex $prop 1]
  set prior [lindex $prop 2]
  set icon  [lindex $prop 3]
  set param [script:decrypt:nickmenu $param $gname $uname $nname $stats $say $prior $icon]

  script:start $file $param
}

proc script:command:exit {interp args} {
  catch "$interp eval {destroy .}"
  after idle "interp delete \{$interp\}; script:refresh"
  return -code return
}

proc script:command:addExt {file interp args} {
global script
  eval script:command:delExt {$file} {$interp} $args

#            +------------------------------------ Subject
#            |   +-------------------------------- Say
#            |   |   +---------------------------- Priority
#            |   |   |   +------------------------ Thread
#            |   |   |   |   +-------------------- From
#            |   |   |   |   |   +---------------- Nick
#            |   |   |   |   |   |  +------------- ExtTag
#            |   |   |   |   |   |  |  +---------- ExtVals
#            |   |   |   |   |   |  |  |   +------ ExtTxt
#            |   |   |   |   |   |  |  |   |  +--- Command
#            |   |   |   |   |   |  |  |   |  |
  set temp {"*" "*" "*" "*" "*" "*" "" "" "*" ""}

  foreach {tag value} $args {
	switch -- $tag {
		-subject  {set temp [lreplace $temp 0 0 $value]}
		-say      {set temp [lreplace $temp 1 1 $value]}
		-priority {set temp [lreplace $temp 2 2 $value]}
		-thread   {set temp [lreplace $temp 3 3 $value]}
		-from     {set temp [lreplace $temp 4 4 $value]}
		-nick     {set temp [lreplace $temp 5 5 $value]}
		-exttag   {set temp [lreplace $temp 6 6 $value]}
		-extvals  {set temp [lreplace $temp 7 7 $value]}
		-exttxt   {set temp [lreplace $temp 8 8 $value]}
		-command  {set temp [lreplace $temp 9 9 $value]}
	}
  }
  lappend script(interp,$file:$interp) $temp
}

proc script:command:delExt {file interp args} {
global script

#            +----------------------------------- Subject
#            |   +------------------------------- Say
#            |   |   +--------------------------- Priority
#            |   |   |   +----------------------- Thread
#            |   |   |   |   +------------------- From
#            |   |   |   |   |   +--------------- Nick
#            |   |   |   |   |   |  +------------ ExtTag
#            |   |   |   |   |   |  |  +--------- ExtVals
#            |   |   |   |   |   |  |  |   +----- ExtTxt
#            |   |   |   |   |   |  |  |   |
  set temp {"*" "*" "*" "*" "*" "*" "" "" "*"}

  foreach {tag value} $args {
	switch -- $tag {
		-subject  {set temp [lreplace $temp 0 0 $value]}
		-say      {set temp [lreplace $temp 1 1 $value]}
		-priority {set temp [lreplace $temp 2 2 $value]}
		-thread   {set temp [lreplace $temp 3 3 $value]}
		-from     {set temp [lreplace $temp 4 4 $value]}
		-nick     {set temp [lreplace $temp 5 5 $value]}
		-exttag   {set temp [lreplace $temp 6 6 $value]}
		-extvals  {set temp [lreplace $temp 7 7 $value]}
		-exttxt   {set temp [lreplace $temp 8 8 $value]}
	}
  }

  set ok  1
  set num 0
  foreach list $script(interp,$file:$interp) {
	set list [lreplace $list end end]
	foreach a $temp b $list {if {$a!=$b} {set ok 0; break}}
	if {$ok} {set script(interp,$file:$interp) [lreplace $script(interp,$file:$interp) $num $num]; break}
	incr num
  }
}

proc script:command:sendMessage {args} {

#           +------------------------------ To
#           |  +--------------------------- Nick
#           |  |  +------------------------ Subject
#           |  |  |  +--------------------- Thread
#           |  |  |  |  +------------------ Priority
#           |  |  |  |  |  +--------------- Say
#           |  |  |  |  |  |  +------------ Type
#           |  |  |  |  |  |  |  +--------- ExtTag
#           |  |  |  |  |  |  |  |  +------ ExtVals
#           |  |  |  |  |  |  |  |  |  +--- ExtTxt
#           |  |  |  |  |  |  |  |  |  |
  set temp {"" "" "" "" "" "" "" "" "" ""}

  foreach {tag value} $args {
	switch -- $tag {
		-to       {set temp [lreplace $temp 0 0 $value]}
		-nick     {set temp [lreplace $temp 1 1 $value]}
		-subject  {set temp [lreplace $temp 2 2 $value]}
		-thread   {set temp [lreplace $temp 3 3 $value]}
		-priority {set temp [lreplace $temp 4 4 $value]}
		-say      {set temp [lreplace $temp 5 5 $value]}
		-exttag   {set temp [lreplace $temp 7 7 $value]}
		-extvals  {set temp [lreplace $temp 8 8 $value]}
		-exttxt   {set temp [lreplace $temp 9 9 $value]}
	}
  }

  eval JabberLib:send:extmsg $temp
}

proc script:refresh {} {
global script

  foreach file $script(files) {
	foreach interp $script(interp,$file) {
		if {![interp exists $interp]}  {set index [lsearch $script(interp) $interp]
						set script(interp) [lreplace $script(interp) $index $index]
						set index [lsearch $script(interp,$file) $interp]
						set script(interp,$file) [lreplace $script(interp,$file) $index $index]
						unset script(interp,$file:$interp)}
	}
  }
}

proc script:match:value {extvals vals} {
  set ok 0
  set exists 0
  foreach {tag val} $vals {
	foreach {etag eval} $extvals {
		switch -- $tag " \
			\{$etag\}   {if {[string match $val $eval]} {set ok 1}; set exists 1}"
	}
	if {!$ok || !$exists} {return 0} else {set ok 0; set exists 0}
  }
  return 1
}

proc script:decrypt:groupmenu {text gname} {
set retext ""
set char ""
set cry1 {%GROUPNAME}
set cry_1 "$gname"
set cry2 {%%}
set cry_2 "%"

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char $char[string index $text $x]

    if { $char==$cry1 } {set retext $retext$cry_1; set char ""} \
      elseif { $char==$cry2 } {set retext $retext$cry_2; set char ""} \
        \
      elseif { "$char[rtrimleft $cry1 $char]"==$cry1 } {} \
      elseif { "$char[rtrimleft $cry2 $char]"==$cry2 } {} \
      else { set retext $retext$char; set char "" }
    }
  return $retext
}

proc script:decrypt:usermenu {text gname uname} {
set retext ""
set char ""
set cry1 {%GROUPNAME}
set cry_1 "$gname"
set cry2 {%USERNAME}
set cry_2 "$uname"
set cry3 {%%}
set cry_3 "%"

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char $char[string index $text $x]

    if { $char==$cry1 } {set retext $retext$cry_1; set char ""} \
      elseif { $char==$cry2 } {set retext $retext$cry_2; set char ""} \
      elseif { $char==$cry3 } {set retext $retext$cry_3; set char ""} \
        \
      elseif { "$char[rtrimleft $cry1 $char]"==$cry1 } {} \
      elseif { "$char[rtrimleft $cry2 $char]"==$cry2 } {} \
      elseif { "$char[rtrimleft $cry3 $char]"==$cry3 } {} \
      else { set retext $retext$char; set char "" }
    }
  return $retext
}

proc script:decrypt:nickmenu {text gname uname nname stats say pri icon} {
set retext ""
set char ""
set cry1 {%GROUPNAME}
set cry_1 "$gname"
set cry2 {%USERNAME}
set cry_2 "$uname"
set cry3 {%NICKNAME}
set cry_3 "$nname"
set cry4 {%STATUS}
set cry_4 "$stats"
set cry5 {%SAY}
set cry_5 "$say"
set cry6 {%PRIORITY}
set cry_6 "$pri"
set cry7 {%ICON}
set cry_7 "$icon"
set cry8 {%%}
set cry_8 "%"

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char $char[string index $text $x]

    if { $char==$cry1 } {set retext $retext$cry_1; set char ""} \
      elseif { $char==$cry2 } {set retext $retext$cry_2; set char ""} \
      elseif { $char==$cry3 } {set retext $retext$cry_3; set char ""} \
      elseif { $char==$cry4 } {set retext $retext$cry_4; set char ""} \
      elseif { $char==$cry5 } {set retext $retext$cry_5; set char ""} \
      elseif { $char==$cry6 } {set retext $retext$cry_6; set char ""} \
      elseif { $char==$cry7 } {set retext $retext$cry_7; set char ""} \
      elseif { $char==$cry8 } {set retext $retext$cry_8; set char ""} \
        \
      elseif { "$char[rtrimleft $cry1 $char]"==$cry1 } {} \
      elseif { "$char[rtrimleft $cry2 $char]"==$cry2 } {} \
      elseif { "$char[rtrimleft $cry3 $char]"==$cry3 } {} \
      elseif { "$char[rtrimleft $cry4 $char]"==$cry4 } {} \
      elseif { "$char[rtrimleft $cry5 $char]"==$cry5 } {} \
      elseif { "$char[rtrimleft $cry6 $char]"==$cry6 } {} \
      elseif { "$char[rtrimleft $cry7 $char]"==$cry7 } {} \
      elseif { "$char[rtrimleft $cry8 $char]"==$cry8 } {} \
      else { set retext $retext$char; set char "" }
    }
  return $retext
}

proc script:decrypt:Message {text sub say pri thr from nick exttag extvals exttxt} {
set retext ""
set char ""
set cry1 {%SUB}
set cry_1 "$sub"
set cry2 {%SAY}
set cry_2 "$say"
set cry3 {%PRI}
set cry_3 "$pri"
set cry4 {%THR}
set cry_4 "$thr"
set cry5 {%FROM}
set cry_5 "$from"
set cry6 {%NICK}
set cry_6 "$nick"
set cry7 {%EXTTAG}
set cry_7 "$exttag"
set cry8 {%EXTVALS}
set cry_8 "$extvals"
set cry9 {%EXTTXT}
set cry_9 "$exttxt"
set cry10 {%%}
set cry_10 "%"

  for {set x "0"} {$x<[string length $text]} {incr x} {
    set char $char[string index $text $x]

    if { $char==$cry1 } {set retext $retext$cry_1; set char ""} \
      elseif { $char==$cry2 } {set retext $retext$cry_2; set char ""} \
      elseif { $char==$cry3 } {set retext $retext$cry_3; set char ""} \
      elseif { $char==$cry4 } {set retext $retext$cry_4; set char ""} \
      elseif { $char==$cry5 } {set retext $retext$cry_5; set char ""} \
      elseif { $char==$cry6 } {set retext $retext$cry_6; set char ""} \
      elseif { $char==$cry7 } {set retext $retext$cry_7; set char ""} \
      elseif { $char==$cry8 } {set retext $retext$cry_8; set char ""} \
      elseif { $char==$cry9 } {set retext $retext$cry_9; set char ""} \
      elseif { $char==$cry10 } {set retext $retext$cry_10; set char ""} \
        \
      elseif { "$char[rtrimleft $cry1 $char]"==$cry1 } {} \
      elseif { "$char[rtrimleft $cry2 $char]"==$cry2 } {} \
      elseif { "$char[rtrimleft $cry3 $char]"==$cry3 } {} \
      elseif { "$char[rtrimleft $cry4 $char]"==$cry4 } {} \
      elseif { "$char[rtrimleft $cry5 $char]"==$cry5 } {} \
      elseif { "$char[rtrimleft $cry6 $char]"==$cry6 } {} \
      elseif { "$char[rtrimleft $cry7 $char]"==$cry7 } {} \
      elseif { "$char[rtrimleft $cry8 $char]"==$cry8 } {} \
      elseif { "$char[rtrimleft $cry9 $char]"==$cry9 } {} \
      elseif { "$char[rtrimleft $cry10 $char]"==$cry10 } {} \
      else { set retext $retext$char; set char "" }
    }
  return $retext
}
